package com.zhongzheng.modules.bank.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.modules.bank.bo.ExamQuestionAddBo;
import com.zhongzheng.modules.bank.bo.ExamQuestionEditBo;
import com.zhongzheng.modules.bank.bo.ExamQuestionQueryBo;
import com.zhongzheng.modules.bank.domain.ExamQuestion;
import com.zhongzheng.modules.bank.mapper.ExamQuestionMapper;
import com.zhongzheng.modules.bank.service.IExamQuestionService;
import com.zhongzheng.modules.bank.vo.ExamQuestionVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 试卷题目关系Service业务层处理
 *
 * @author hjl
 * @date 2021-10-22
 */
@Service
public class ExamQuestionServiceImpl extends ServiceImpl<ExamQuestionMapper, ExamQuestion> implements IExamQuestionService {

    @Autowired
    private ExamQuestionMapper examQuestionMapper;

    @Override
    public ExamQuestionVo queryById(Long id){
        ExamQuestion db = this.baseMapper.selectById(id);
        return BeanUtil.toBean(db, ExamQuestionVo.class);
    }

    @Override
    public List<ExamQuestionVo> queryList(ExamQuestionQueryBo bo) {
        LambdaQueryWrapper<ExamQuestion> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getExamId() != null, ExamQuestion::getExamId, bo.getExamId());
        lqw.eq(bo.getQuestionId() != null, ExamQuestion::getQuestionId, bo.getQuestionId());
        lqw.eq(bo.getSort() != null, ExamQuestion::getSort, bo.getSort());
        return entity2Vo(this.list(lqw));
    }

    @Override
    public List<ExamQuestionVo> getList(ExamQuestionQueryBo bo) {
        return examQuestionMapper.getList(bo);
    }

    @Override
    public List<ExamQuestionVo> getAppList(ExamQuestionQueryBo bo) {
        return examQuestionMapper.getAppList(bo);
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<ExamQuestionVo> entity2Vo(Collection<ExamQuestion> collection) {
        List<ExamQuestionVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, ExamQuestionVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<ExamQuestion> page = (Page<ExamQuestion>)collection;
            Page<ExamQuestionVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(ExamQuestionAddBo bo) {
        ExamQuestion add = BeanUtil.toBean(bo, ExamQuestion.class);
        validEntityBeforeSave(add);
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(ExamQuestionEditBo bo) {
        ExamQuestion update = BeanUtil.toBean(bo, ExamQuestion.class);
        validEntityBeforeSave(update);
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(ExamQuestion entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
